README file for gpumpg
======================

This is gpumpg, a tool for solving mean-payoff games on the GPU.

Installation
------------

**Dependencies**

- C++ compiler, e.g. gcc or msvc.
- [CMake](https://cmake.org/).
- [Boost](http://www.boost.org/) 1.61 or higher.
  On Windows, you need to set the BOOST_ROOT environment variable to the root of
  the boost installation and compile the static boost libraries.
- OpenCL headers and runtime library for your device, supporting OpenCL 1.2:
    - [Intel SDK for OpenCL Applications](https://software.intel.com/en-us/intel-opencl).
    - [AMD APP SDK](http://developer.amd.com/tools-and-sdks/opencl-zone/amd-accelerated-parallel-processing-app-sdk).
    - [Nvidia CUDA Toolkit](https://developer.nvidia.com/cuda-toolkit).


**Compilation**

    $ mkdir build
    $ cd build
    $ cmake ..
    $ cmake --build .

Usage
-----

    $ mpgsolver [-d <DEVICE>] FILE

License
-------

Copyright (C) 2016 Philipp Meyer.

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
