#pragma once

#include <boost/program_options.hpp>
#include <boost/optional.hpp>

namespace po = boost::program_options;

namespace controller {

struct Options {
    std::string input_file;
    std::string output_file;
    bool help;
};

class OptionParser {
private:
    po::options_description help_options_desc_;
    po::options_description hidden_options_desc_;
    po::positional_options_description positional_options_desc_;
    po::options_description options_desc_;

public:
    OptionParser();
    ~OptionParser();

    void print_options() const;
    boost::optional<Options> parse_options(const int argc, const char* argv[]) const;
};

}
