#pragma once

#include <vector>

#include <boost/compute.hpp>

namespace ocl {

class OCLModule {
private:
    const std::string name;
    const bool executable;
    std::vector< OCLModule* > dependencies;
    unsigned int references;

    void init_module();
    void clean_module();

protected:
    bool initialized;

    virtual void init() {}
    virtual void clean() {}
    virtual void execute_module() {}

    void addDependency(OCLModule* dependency);

public:
    OCLModule(const std::string& name, const bool executable = false);
    virtual ~OCLModule() {};

    void execute();

    void print_debug(std::string str);
};

}
