#ifndef CL_COMPILE

#pragma once

#endif

#define DISTANCE_INFINITY       CL_LONG_MAX
#define DISTANCE_MINUS_INFINITY CL_LONG_MIN

#define RETREAT_EDGE            CL_UINT_MAX

typedef struct tag_node_value {
    /*
     * The value variables contains the fraction of the current guess for
     * the value of the node, or the actual value when the node is solved.
     */
    weight_t value_num;
    weight_t value_den;
} node_value;

typedef struct tag_node_interval {
    /*
     * The value_lower and value_upper variables containn fractions for
     * the lower and upper bound on the value of the node.
     */
    weight_t value_lower_num;
    weight_t value_lower_den;
    weight_t value_upper_num;
    weight_t value_upper_den;
} node_interval;

#ifndef CL_COMPILE

BOOST_COMPUTE_ADAPT_STRUCT(node_value, node_value, (
    value_num, value_den
))

BOOST_COMPUTE_ADAPT_STRUCT(node_interval, node_interval, (
    value_lower_num, value_lower_den, value_upper_num, value_upper_den
))

#endif

