#include "OCLSolver.h"

namespace ocl {

OCLSolver::OCLSolver(OCLDriver* driver, OCLArena* arena) :
    OCLModule("OCL Solver", true),
    driver(driver),
    arena(arena)
{
    successors = new id_t[arena->n_nodes];

    addDependency(arena);
}

OCLSolver::~OCLSolver() {
    delete[] successors;
}

void OCLSolver::init() {
    successor_buffer      = new compute::vector<id_t>(arena->n_nodes, driver->context);
}

void OCLSolver::clean() {
    compute::copy(successor_buffer->cbegin(), successor_buffer->cend(), successors, driver->queue);

    delete successor_buffer;
}

}
