#pragma once

#include "ocl/OCLModule.h"
#include "ocl/arena/OCLArena.h"

namespace ocl {

class OCLSolver : public OCLModule {
protected:
    OCLDriver* driver;
    OCLArena* arena;

    id_t* successors;

    compute::vector<id_t>* successor_buffer;

    virtual void init();
    virtual void clean();
    virtual void execute_module() = 0;

public:
    OCLSolver(OCLDriver* driver, OCLArena* arena);
    ~OCLSolver();

    virtual void print_solution(std::ostream& out) const = 0;
};

}
