#pragma once

#include <cstdint>

#include "ParserUtil.h"
#include "Arena.h"

namespace parser {

#pragma pack(push)
#pragma pack(1)
struct node_entry {
    int32_t node_id;
    uint32_t succs_begin;
};
struct edge_entry {
    int32_t successor;
    uint32_t color;
};
#pragma pack(pop)

struct BINParseResult {
    uint32_t n_nodes;
    uint32_t n_edges;
    uint32_t n_colors;

    int32_t initial_node;

    uint32_t* ids;
    uint32_t* bits;
    uint32_t* succs_begin;
    uint32_t* succs;
    uint32_t* colors;
};

class BINParser {
public:

    BINParser();
    ~BINParser();

    BINParseResult* parse(const std::string& file_nodes, const std::string& file_edges) const;
};

}
