#pragma once

#include "cpphoafparser/parser/hoa_parser.hh"
#include "cpphoafparser/ast/boolean_expression.hh"
#include "cpphoafparser/consumer/hoa_consumer.hh"
#include "cpphoafparser/consumer/hoa_consumer_null.hh"

#include "Arena.h"

namespace hoa = cpphoafparser;

namespace parser {

class HOPGConsumer : public hoa::HOAConsumerNull {
private:
    Arena::node cur_node;

public:
    Arena* arena;

    HOPGConsumer();
    ~HOPGConsumer();

    void addState(
            unsigned int id,
            std::shared_ptr< std::string > info,
            label_expr::ptr labelExpr,
            std::shared_ptr< int_list > accSignature
    );

    void addEdgeWithLabel(
            unsigned int stateId,
            label_expr::ptr labelExpr,
            const int_list &conjSucessors,
            std::shared_ptr< int_list > accSignature
    );

    void notifyEndOfState(unsigned int stateId);
};

class HOPGParser {
private:

public:
    HOPGParser();
    ~HOPGParser();

    Arena* parse(const std::string& filename) const;
};

}
