#pragma once

#include <boost/spirit/include/qi.hpp>

namespace spirit = boost::spirit;
namespace qi = boost::spirit::qi;
namespace phx = boost::phoenix;
namespace fusion = boost::fusion;

namespace parser {

class parser_error : public std::runtime_error {
public:
    parser_error(const std::string& what_arg) : std::runtime_error(what_arg) { }
};

struct make_error_message_f {
    template <typename ...> struct result { using type = std::string; };

    template <typename Info, typename F, typename L>
    std::string operator()(const Info& info, F f, L l) const {
        std::ostringstream oss;
        oss << "Expecting " << info << " here: \"" << std::string(f,l) << "\"";
        return oss.str();
    }
};

const static phx::function<make_error_message_f> make_error_message;

}
